#include "display.h"

Display::Display (QWidget *parent) : QWidget(parent)
{
    channel = new QList<int>;
}

void Display::addData(int d)
{
    channel->push_back (d);

    if (channel->size() > width)
    {
        channel->removeFirst();
        update();
    }
}

void Display::resizeEvent (QResizeEvent *)
{
    int w = this->geometry().width();
    int h = this->geometry().height();
    unit = h/10.0;
    width = (w/unit)*unit;
    height = (h/unit)*unit;
    resize (width, height);
}

void Display::paintEvent(QPaintEvent *)
{
    QPainter painter(this);
    painter.setRenderHint (QPainter::Antialiasing, true);    
    painter.fillRect(0, 0, width, width, QColor(150, 180, 120));

    QPainterPath path1;
    QPen pen1 (QColor (160, 200, 130), 1);
    pen1.setStyle(Qt::DashLine);
    painter.setPen(pen1);
    
    for (int i = 0; i < width; i += unit) {
        path1.moveTo (i, 0);
        path1.lineTo (i, height);
    }
    for (int i = 0; i < height; i += unit) {
        path1.moveTo (0, i);
        path1.lineTo (width, i);
    }
    painter.drawPath (path1);

    QPainterPath path2;
    QPen pen2 (QColor (160, 200, 130), 2);
    pen2.setStyle(Qt::SolidLine);
    painter.setPen(pen2);    
    
    for (int i = unit; i < width; i += 2*unit) {
        path2.moveTo (i, 0);
        path2.lineTo (i, height);
    }
    for (int i = unit; i < height; i += 2*unit) {
        path2.moveTo (0, i);
        path2.lineTo (width, i);
    }
    painter.drawPath (path2);

    QPen pen3 (QColor(200, 240, 160), 4);
    painter.setPen (pen3);
    QPainterPath path3;
    for (int i = 0; i < channel->size(); i++)
    {
        path3.lineTo (QPoint(i, (height/255.0)*(channel->at(i))));
    }
    painter.drawPath(path3);
}