#include "scope.h"

Scope::Scope (QWidget *parent) : QWidget (parent)
{
    resize(400, 400);
    h = new QHBoxLayout;
    o = new Display;
    h->addWidget(o);
    setLayout(h);

    serial = new QSerialPort(this);
    // propojeni signalu serioveho portu se slotem teto  tridy
    connect(serial, SIGNAL(readyRead()), this, SLOT(readData()));
    // nazev virtualni COM portu v OS
    // Linux: /dev/ttyACM0, nebo treba /dev/ttyUSB0, ...
    serial->setPortName ("COM16");
    // rychost kom. linky
    serial->setBaudRate (QSerialPort::Baud19200);
    // delka datoveho slova
    serial->setDataBits(QSerialPort::Data8);

    // osetreni otevreni portu
    if(!serial->open(QIODevice::ReadWrite))
    {
        QMessageBox::warning(this, tr("Serial Scope"), tr("Nepodařilo se otevřít COM port"), QMessageBox::Cancel);
    }
}

void Scope::readData ()
{
    data.append(serial->readAll());
    int j = 0;
    while ((j = data.indexOf(";", j)) != -1) {
	cislo = data.mid (0, j);
	o->addData(cislo.toUInt());
        data.remove(0, j+1);
    }
}